





          |
          | foldED
          |
          | MS-DOS world's folding editor
          |
          | Brief documentation for the shareware version
          |
          | Copyright (program and documentation)
          | 1987-1991 by Jasper Neumann, Helmut Ritz, and Till Krner
          |
          | mebsware
          | Gesellschaft fr Softwareerstellung
          | Friedrich Buckert et al. GbR
          | Roermonder Strae 135a
          | D-W5100 Aachen
          | Fed. Rep. of Germany
          |
          | Tel +49 241 872806
          | Fax +49 241 872676
          |


You may use this shareware version of foldED as often as you like for
one month and give away any number of copies of the shareware version
of foldED and its documentation as long as:

  - you don't omit and don't add any files
  - you don't modify any file
  - no money changes hands

We make no warranties as to the contents of this manual or the therein
described software and specifically disclaim any implied warranties of
fitness for any particular purpose.

We work hard to deliver foldED and the other programs error-free.
However if you discover errors or have ideas of improvement please let
us know.

This shareware version of foldED differs from the full version:

  - the amount of free memory is limited to 128 kilobytes
  - you cannot adapt foldED directly
  - everytime you save a file or print from within foldED a message
    appears whether you want to print the order form
  - some auxiliary programs are missing
  - no comprehensive manual
foldED is a new programmer's editor aiming at people who have to write
and/or maintain large amounts of structured text.

These people know how cumbersome it can be to page or scroll through
large listings on (small) computer screens. With standard editors the
practical limit to the size of source code is reached after only a few
hundred lines of source code. Anything larger than that has to be
broken into more manageable pieces (i.e. files) which then have to be
edited separately. As a result it can be quite difficult to keep track
of changes affecting not only one but many of those smaller pieces.

Users of word processors know a method of structuring documents as
"outlining". But until now it was not possible to use outlining with
program source code because the interpreters/compilers dislike the
word processors' embedded control codes which are necessary for
outlining.

However foldED hides its control codes, and its hiding-mechanism is
adaptable to virtually all programming languages. Included with foldED
are ready-to-use adaptions for Pascal, C, Modula-2, Assembler, even
TeX, and BASIC, not to mention Ada, FORTRAN, and dBase/Clipper as well
as a program to build more of those adaptions. But even if you only
need a fast editor for ASCII files (with or without outlining
features) you will soon wonder how you could live without foldED.

In order to faciliate the process of getting used to foldED its
commands are compatible to the editor of Borland's Turbo products and
WordStar.

Standard features supported by foldED include:
        - Search and replace
        - Textblocks
        - Auto-indentation
        - Contextsensitive helpsystem
        - ASCII-table
        - Mouse-support
        - Support of standard video-adapters
          (MDA, CGA, Hercules, EGA, VGA)

But that's not all. foldED shines with:
        - Column blocks
        - Sorting of blocks
        - Indentation of blocks
        - Markers
        - Keyboard macros for command sequences and phrases
        - Use DOS from inside of foldED (shell escape)
        - Automatic handling of include files
        - Word wrap
        - Boxgraphics
        - Special video modes on standard video adapters
          (e.g. 35 or 43 lines by 90 columns on a HGC)
        - Integrated Calculator

Be warned! By folding foldED's folds you will easily loose your sense
for the size of your texts! 10000 lines of text look VERY similar to
only twenty.
Command summary:

Cursor movements
  ^S, <-       character left
  ^D, ->         "       right
  ^A, ^<-      word left
  ^F, ^->        "  right
  ^E, Up       line up
  ^X, Dn         "  down
  ^R, PgUp     page up
  ^C, PgDn       "  down
  ^O E  ^Up    up to next headline
  ^O X  ^Dn    down to next headline
  ^Q S, Home   to left end of line
  ^Q D, End    to right end of line
  ^Q E, ^Home  to top of page
  ^Q X, ^End   to bottom of page
  ^Q R, ^PgUp  to top of fold
  ^Q C, ^PgDn  to end of fold
  ^Q B         to beginning of block
  ^Q K         to end of block
  ^Q V         to begin of old block
  ^Q N         to end of old block
  ^Q n         to marker n (0-9)
  ^Q G         to global line number
  ^Q P         to last cursor position
  ^Q O         jump to pos. on screen
  ^Q M         scroll to middle
  ^Z             "    up
  ^W             "    down

Insert & delete
  ^N           insert line
  Ret          enter new line
  ^Y Y         delete whole line
  ^Q Bs          "    to begin of line
  ^Q Y           "    to end of line
  ^T             "    right word
  ^Bs            "    left word
  ^G, Del      delete char under cursor
  Bs             "   left character

Fold commands
  ^O I, F4     enter fold (in)
  ^O O, F5     leave fold (out)
  ^O N         create new fold
  ^O Y         unfold
  ^O R         read & fold includefile
  ^O W         write fold as includefile

Macro commands
  ^B           begin/end macro definition
  ^O V         view macro definitions
  ^O P         put macro-file
  ^O G         get macro-file
  ^O M         merge macros from file
Block commands
  ^K B, F7     set block begin marker
  ^K K, F8     set block end marker
  ^K T, F6     mark single word
  ^K L           "  line
  ^K H, F9     hide/display block
  ^K C         copy ~
  ^K V         move ~
  ^K Y         delete ~
  ^K I         indent ~
  ^K R         read ~ from file
  ^K W         write ~ to file
  ^K S         sort ~
  ^K P         print ~
  ^K Z         make up ~
  ^K E         enter (fill in) ~
  ^K X         exchange old/new ~
  ^K N         column/text block mode

Options
  ^V, Ins      toggle insert/overwrite
  ^Q W         right margin (word-wrap)
  ^Q I         auto indent on/off
  ^O D         hide/display markers
  ^Q Z         set switches to default
  ^K A         load adaption-file
  ^O A         online adaption
  ^O H         help on errors on/off
  ^K G         switch CRT-mode

Miscellaneous commands
  ^K Q, Esc    [save all and] quit
  ^K F, F3     [save all and] new file
  ^K D, F2     save all and stay
  ^O F         save as...
  ^Q L         restore line
  ^Q F         find
  ^Q A         find & replace
  ^L           repeat last find
  ^Q (, ^Q )   search matching braces
  ^P           control character prefix
  ^P^Z         ASCII-table
  ^I, >|      tab
  |<          back-tab
  ^K n         set marker n (0-9)
  ^O T         change case of word
  ^O L         log to new directory
  ^Q T         insert time stamp
  ^O C         calculator
  ^O B         draw boxes
  ^K O         copy with second cursor
  ^O Q         screen saver
  ^O S         DOS shell escape
  ^O K         DOS command
  ^K M, F10    menu
  ^U, Esc      abort command
  ^J, F1       help
