echo off
ECHO  This sample batch procedure is to be used instead of CLE.BAT, if you
ECHO  use a MAKE utility.  It executes your MAKE utility directing its messages
ECHO  to a file.  In case of errors, this procedure executes VersiEdit to view
ECHO  the message file.  At this point you would bring in the source code file
ECHO  in error and correct it.  After which, the process is repeated from the
ECHO  beginning.
ECHO 
ECHO  This procedure must be modified to reflect your programming environment
ECHO  as indicated by remarks in the text of the procedure.
goto end
echo off
REM  After modification, this procedure is executed by entering at DOS prompt:
REM  MAK "file", where "file" is the name of your MAKE parameter.  The "file"
REM  is also the value of the %1 parameter in this procedure.
REM
REM  MODIFICATION INSTRUCTIONS:
REM
REM  1.  Make sure that this file is backed up.
REM  2.  Remove the initial lines up to and including "goto end".
REM  3.  Modify the MAKE statement as needed for your environment.  %1 para-
REM      meter contains the name of your MAKE parameter file.
REM
REM  ** END OF MODIFICATION INSTRUCTIONS **
:beg
REM Execute Make program
make %1 >err.msg
if not ERRORLEVEL 1 goto ex
REM An error has occurred, edit error message file.
REM Based on the contents of the error message file,
REM you would manually bring in the source code file that is in error.
e err.msg
REM  Allow exit from the loop.
echo 
echo 
echo ** Press ^C to Abort, Any Other Key to Continue **
pause
goto beg
:ex
REM  Display the message file.  It may contain warning messages that
REM  did not trigger the error processing loop.
type err.msg
:end

